<script setup lang="ts">
import { useBranchStore } from '@/stores/branch'
import { useExpenseStore } from '@/stores/expense'
import type { Branch } from '@/types/Branch'
import type { Expense } from '@/types/Expense'
import { computed, nextTick, ref, onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

const expensesStore = useExpenseStore()
const branchStore = useBranchStore()
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Branch Name',
    key: 'branchName',
    value: (item: any | Branch) => item.branchName.address
  },

  {
    title: 'Bill Type',
    key: 'billType',
    value: 'billType'
  },
  {
    title: 'Total Amount',
    key: 'totalAmount',
    value: 'totalAmount'
  },
  {
    title: 'Date',
    key: 'createDate',
    value: (expense: any) => new Date(expense.createDate).toLocaleDateString('en-GB')
  },

  { title: 'Actions', key: 'actions', sortable: false }
]

const page = ref(1)
const itemsPerPage = ref<any>(10)
const tab = ref(null)
const pageCount = computed(() => {
  return Math.ceil(expensesStore.expenses.length / itemsPerPage.value)
})
const refForm = ref<VForm | null>(null)
let editedIndex = -1
const dialog = ref(false)
const loading = ref(false)
const form = ref(false)
const dialogDelete = ref(false)
const dialogView = ref(false)

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    expensesStore.clearForm()
  })
}

async function deleteItemConfirm() {
  // Delete item from list
  await expensesStore.deleteExpense()
  closeDelete()
}

async function deleteItem(item: Expense) {
  if (!item.id) return
  await expensesStore.getExpense(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    expensesStore.clearForm()
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  closeDialog()
  await expensesStore.saveExpense()
}

function showExpense(item: Expense) {
  selectedExpense = item
  dialogView.value = true
}

function closeDialogView() {
  dialogView.value = false
}

let selectedExpense: Expense | null = null

onMounted(async () => {
  await expensesStore.getExpenses()
  await branchStore.getBranchs()
})

const search = ref<string>('')

const formattedExpenses = computed(() =>
  expensesStore.expenses.map((expense) => ({
    ...expense
  }))
)

const filteredUsers = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedExpenses.value.filter(
    (expense) =>
      (expense.name.toLowerCase().includes(searchLower) &&
        (tab.value === 1 || (tab.value === 2 && expense.billType === 'Water'))) ||
      (tab.value === 3 && expense.billType === 'Electricity') ||
      (tab.value === 4 && expense.billType === 'Others')
  )
})
</script>
<template>
  <div class="text-right">
    <v-card-title class="d-flex align-center pe-2">
      <h1 style="text-align: left" class="ml-5">EXPENSES</h1>
      <v-spacer></v-spacer>
      <v-dialog v-model="dialog" persistent width="600">
        <template v-slot:activator="{ props }">
          <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
            <v-icon icon=" mdi-playlist-edit" size="25px" class="mr-2" color="#FFFFFF"></v-icon>
            <div style="text-align: center; color: aliceblue">Add Expense</div>
          </v-btn>
        </template>
        <v-card title="Expense" class="pt-6" style="text-align: center"
          ><v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
              <v-container>
                <v-row justify="center">
                  <v-col cols="12" sm="12">
                    <v-text-field
                      v-model="expensesStore.editedExpense.name"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'required']"
                      class="mb-2"
                      clearable
                      label=" Username"
                      variant="outlined"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="12">
                    <v-combobox
                      v-model="expensesStore.editedExpense.branchName"
                      :items="branchStore.branchs"
                      :readonly="loading"
                      item-title="name"
                      item-value="id"
                      class="mb-2"
                      label="Select Branch"
                      variant="outlined"
                      :return-object="true"
                    ></v-combobox>
                  </v-col>

                  <v-col cols="12" sm="6">
                    <v-combobox
                      v-model="expensesStore.editedExpense.billType"
                      class="mb-2"
                      :items="['Water', 'Electricity', 'Others']"
                      label="Select Type"
                      variant="outlined"
                      :return-object="true"
                    ></v-combobox>
                  </v-col>
                  <!-- <v-col cols="12" sm="6">
                    <v-text-field
                      :readonly="loading"
                      class="mb-2"
                      label="Other"
                      variant="outlined"
                    ></v-text-field>
                  </v-col> -->

                  <v-col cols="12" sm="6">
                    <v-text-field
                      v-model="expensesStore.editedExpense.totalAmount"
                      :readonly="loading"
                      class="mb-2"
                      clearable
                      label="Total Amount"
                      variant="outlined"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12">
                    <v-text-field
                      v-model="expensesStore.editedExpense.createDate"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'required']"
                      class="mb-2"
                      label="Open Date"
                      variant="outlined"
                      type="date"
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-container>
            </v-form>
            <small class="div">*indicates required field</small> </v-card-text
          ><v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="red"
              style="width: 150px; height: 50px"
              variant="flat"
              @click="closeDialog()"
              class="ms-2"
              >Cancel</v-btn
            >

            <v-btn
              style="width: 150px; height: 50px"
              variant="flat"
              @click="save()"
              class="ms-3"
              color="success"
              >Save</v-btn
            >
          </v-card-actions></v-card
        > </v-dialog
      ><v-text-field
        class="ma-2"
        v-model="search"
        prepend-inner-icon="mdi-magnify"
        density="compact"
        label="Search"
        single-line
        flat
        hide-details
        variant="solo-filled"
      ></v-text-field>
    </v-card-title>
  </div>

  <v-dialog v-model="dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >you want to delete this info? 🗑️</v-card-title
      >
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="red"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="closeDelete"
          >Cancel</v-btn
        >
        <v-btn
          color="success"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="deleteItemConfirm"
          >OK</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <!-- <v-dialog v-model="dialogView" persistent width="600">
    <v-card
      ><v-card-title class="font ma-4 pt-6" style="text-align: center">Bill</v-card-title
      ><v-card-actions
        ><v-spacer></v-spacer
        ><v-btn
          color="red"
          variant="flat"
          style="width: 150px; height: 50px"
          class="mb-3"
          @click="closeDialog()"
          >Close</v-btn
        >
      </v-card-actions></v-card
    ></v-dialog -->
  <v-dialog v-model="dialogView" persistent width="400">
    <v-card>
      <v-card-title class="font ma-4 pt-6" style="text-align: center"
        >Expense Details
      </v-card-title>
      <v-card-text>
        <div v-if="selectedExpense" style="text-align: start">
          <p>Date : {{ new Date(selectedExpense.createDate).toLocaleDateString('en-GB') }}</p>

          <p>Name : {{ selectedExpense.name }}</p>

          <p>Branch : {{ selectedExpense.branchName?.address }}</p>
          <p>Bill Type : {{ selectedExpense.billType }}</p>
          <p>Total Amount : {{ selectedExpense.totalAmount }}</p>
        </div>
      </v-card-text>
      <v-card-actions
        ><v-spacer></v-spacer>
        <v-btn color="red" variant="flat" class="mb-3" @click="closeDialogView()">Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>

  <v-row>
    <v-col>
      <v-tabs v-model="tab" align-tabs="end" color="brown">
        <v-tab :value="1">Total</v-tab>
        <v-tab :value="2">Water</v-tab>
        <v-tab :value="3">Electricity</v-tab>
        <v-tab :value="4">Others</v-tab>
        <v-tab :value="5">Graph</v-tab>
      </v-tabs>
      <v-window v-model="tab">
        <v-window-item :value="1">
          <div>
            <v-data-table
              v-model:page="page"
              :headers="headers"
              :items="filteredUsers"
              :items-per-page="itemsPerPage"
              ><template v-slot:bottom>
                <div class="text-center pt-2">
                  <v-pagination v-model="page" :length="pageCount"></v-pagination>
                </div> </template
              ><template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
                <v-icon size="small" @click="showExpense(item)"> mdi-eye </v-icon>
              </template></v-data-table
            >
          </div>
        </v-window-item>
        <v-window-item :value="2">
          <div>
            <v-data-table
              v-model:page="page"
              :headers="headers"
              :items="filteredUsers"
              :items-per-page="itemsPerPage"
              ><template v-slot:bottom>
                <div class="text-center pt-2">
                  <v-pagination v-model="page" :length="pageCount"></v-pagination>
                </div> </template
              ><template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
                <v-icon size="small" @click="showExpense(item)"> mdi-eye </v-icon>
              </template></v-data-table
            >
            <!-- <v-col style="text-align: end"><v-btn color="pink">สรุปค่าใช้จ่าย</v-btn></v-col> -->
          </div>
        </v-window-item>
        <v-window-item :value="3">
          <div>
            <v-data-table
              v-model:page="page"
              :headers="headers"
              :items="filteredUsers"
              :items-per-page="itemsPerPage"
              ><template v-slot:bottom>
                <div class="text-center pt-2">
                  <v-pagination v-model="page" :length="pageCount"></v-pagination>
                </div> </template
              ><template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
                <v-icon size="small" @click="showExpense(item)"> mdi-eye </v-icon>
              </template></v-data-table
            >
          </div>
        </v-window-item>
        <v-window-item :value="4">
          <div>
            <v-data-table
              v-model:page="page"
              :headers="headers"
              :items="filteredUsers"
              :items-per-page="itemsPerPage"
              ><template v-slot:bottom>
                <div class="text-center pt-2">
                  <v-pagination v-model="page" :length="pageCount"></v-pagination>
                </div> </template
              ><template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
                <v-icon size="small" @click="showExpense(item)"> mdi-eye </v-icon>
              </template></v-data-table
            >
          </div>
        </v-window-item>
      </v-window>
    </v-col>
  </v-row>
</template>
<style>
div {
  font-family: 'Kanit';
}
</style>
